#!/bin/bash
# This is the horror shell script to create an automatic install for
# Windoze.
# Note that I use sed to create a setup file
# Some files have special names and positions in my development
# environment, I replace them with normal file names in the process.

# use iss.sh >iss.txt
# copy the resulting iss.txt to the location of your Windows installation
# of bigFORTH, and start the setup compiler there.

cat <<EOT | sed -e 's:$:
:g'
; This is the setup script for bigFORTH on Windows
; Setup program is Inno Setup

[Setup]
Bits=32
AppName=MINOS
AppVerName=MINOS $(date '+%d%b%Y' | tr '[A-Z]' '[a-z]')
AppCopyright=Copyright  1998-$(date '+%Y') by Bernd Paysan
DefaultDirName=bigforth
DefaultGroupName=bigFORTH
AllowNoIcons=1
LicenseFile=COPYING

[Dirs]
{app}\icons
{app}\help
{app}\pattern
{app}\doc

[Files]
; Parameter quick reference:
;   "Source filename", "Dest. filename", Copy mode, Flags
$(if [ "${1-$USER@$(domainname -d)}" = "berndxx@paysan.nom" ]
then
  make dist-files | grep -v 'const.fm' | sed \
  -e 's:/:\\:g' \
  -e 's:^bigforth\\\(README.*\)$:"\1", "{app}\\\1.txt", copy_normal, flag_isreadme:g' \
  -e 's:^bigforth\\bigforth\(\.c\)$:"bigforth\1", "{app}\\bigforth\1", copy_normal,:g' \
  -e 's:^bigforth\\bigforth$:"bfwin32.exe", "{app}\\bigforth.exe", copy_normal,:g' \
  -e 's:^bigforth\\bigforth\(.*\)$:"bfwin32\1", "{app}\\bigforth\1", copy_normal,:g' \
  -e 's:^bigforth\\xbigforth$:"xbigforth.exe", "{app}\\xbigforth.exe", copy_normal,:g' \
  -e 's:^bigforth\\forthker$:"win32.exe", "{app}\\forthker.exe", copy_normal,:g' \
  -e 's:^bigforth\\forthker\(.*\)$:"win32\1", "{app}\\forthker\1", copy_normal,:g' \
  -e 's:^bigforth\\\(.*\)$:"\1", "{app}\\\1", copy_normal,:g'
else
  make dist-files | grep -v start32.scr | sed \
  -e 's:/:\\:g' \
  -e 's:^bigforth\\\(README.txt\)$:"\1", "{app}\\\1", copy_normal, flag_isreadme:g' \
  -e 's:^bigforth\\\(README\)$:"\1.txt", "{app}\\\1.txt", copy_normal, flag_isreadme:g' \
  -e 's:^bigforth\\\(.*\)$:"\1", "{app}\\\1", copy_normal,:g'
fi | grep -v 'xbigforth\.sys' | grep -v 'float.bfm' | sort -u)
"makewin.bsh", "{app}\makewin.bsh", copy_normal,
$(if [ "${1-$USER@$(domainname)}" = "bernd@paysan.nom" ]
then
   echo '"makel32.bsh", "{app}\makeload.bsh", copy_normal,'
else
   echo '"makeload.bsh", "{app}\makeload.bsh", copy_normal,'
fi)

[Icons]
; Parameter quick reference:
;   "Icon title", "File name", "Parameters", "Working dir (can leave blank)",
;   "Custom icon filename (leave blank to use the default icon)", Icon index
"MINOS", "{app}\xbigforth.exe", "", "{app}", "{app}\minos.ico", 0
"Theseus", "{app}\xbigforth.exe", "##include theseus.fs minos openw designer open forth", "{app}", "{app}\minos.ico", 0
"bigFORTH", "{app}\bigforth.exe", "", "{app}", , 0
"Remake Kernel", "{app}\bigforth.exe", "##include forth.fb save-target forthker bye", "{app}", , 0
"Remake bigFORTH", "{app}\forthker.exe", "##include startup.fb warning on savesystem bigforth bye", "{app}", , 0
"Remake Float Module", "{app}\bigforth.exe", "##include float.fb m' float savemod float bye", "{app}", , 0
"Remake Minos", "{app}\bigforth.exe", "##use float.fb path ;. include startx.fb savesystem xbigforth bye", "{app}", , 0

[Registry]
; Parameter quick reference:
;   "Root key", "Subkey", "Value name", Data type, "Data", Flags

[Run]
"{app}\bigforth.exe", "##cd '{app}' path ;. include float.fb m' float savemod float bye",
"{app}\bigforth.exe", "##cd '{app}' use float.fb path ;. include startx.fb savesystem xbigforth bye",
"{app}\xbigforth.exe", "##cd '{app}' path ';{app};.' include adjust.m",

[DeleteFiles]
{app}\xbigforth.fi
{app}\float.fm
EOT
